--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
  me._class = #Widget
  me.ancestor = $.include($.Qt.libDir&"/classes/iWidget.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newWidget(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"/classes/iWidget.ls").new()
	obj._class = #Widget
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

----------------------------------------
-- STATIC
----------------------------------------

-- getColor (WidgetID,*color,string) -> color

-- find (int) -> WidgetID
on find (scr,p1,p2)
	put "FIND", p1
	if ilk(p1)=#instance then p1 = p1._id
	id = $.Qt._qx.callWidget(#Widget, #find, p1, p2)
	put id
  if id then 
  	cn = $.Qt._qx.callWidget(id, #className)
  	delete char 1 of cn
  	class = value("$.Qt."&cn)
  	if ilk(class)=#script then
  		obj = class._make(id)
			--me._children.add(obj)
  		return obj
  	end if
  end if
end

----------------------------------------
-- SIGNALS
----------------------------------------

